SystemOrganization addCategory: #MaxClub!

TestCase subclass: #MaxClubTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForNumbers

	|mc|
	mc := MaxClub forNumbers.
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		(5 true 1 5)
		(5 true 2 5)
		(3 false 2 5)	
		(7 true 1 7)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]! !

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForOddCounting

	|mc|
	mc := MaxClub new.
	mc evaluator: [:x| (x select: [:each| each odd]) size ].
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		((2 4) true 1 0)
		((1 2 4) true 1 1)
		((1 2 4) true 2 1)
		((1 2 3 4) true 1 2)
		((0 2 3 4) false 1 2)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]
! !

Object subclass: #MaxClub
	instanceVariableNames: 'members evaluator maximum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MaxClub'!

!MaxClub commentStamp: 'hjo 3/17/2008 13:27' prior: 0!
If you want a MinClub, then just negate the value of evaluator block.!

!MaxClub classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:36'!
forNumbers

	^self new evaluator: [:number | number ]! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
evaluator: monoBlock

	evaluator := monoBlock! !

!MaxClub methodsFor: 'testing' stamp: 'hjo 3/27/2008 11:10'!
isEmpty
	^self members isEmpty! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
maximum

	^maximum! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:28'!
maximum: aNumber

	members := nil.	
	maximum := aNumber! !

!MaxClub methodsFor: 'testing' stamp: 'hjo 3/27/2008 10:57'!
mayAccept: anObject

	^maximum isNil or: [ (evaluator value: anObject) >= maximum ]! !

!MaxClub methodsFor: 'accessing' stamp: 'hjo 3/17/2008 13:29'!
members

	members isNil ifTrue: [members := OrderedCollection new].
	^members! !

!MaxClub methodsFor: 'adding' stamp: 'hjo 3/17/2008 13:30'!
put: anObject

	"Answers boolean, if anObject is acceptted by me"
	| value |
	value := evaluator value: anObject.
	(self maximum isNil or: [value > self maximum]) 
		ifTrue: [ self setMaximum: value member: anObject. ^true ].
	value < self maximum
		ifTrue: [ ^false ].
	value = self maximum
		ifTrue: [ self members add: anObject. ^true ].
	self error: 'No one can reach here.'! !

!MaxClub methodsFor: 'adding' stamp: 'hjo 3/17/2008 13:30'!
putAll: aCollection

	aCollection do: [:object| self put: object ]! !

!MaxClub methodsFor: 'private' stamp: 'hjo 3/17/2008 13:31'!
setMaximum: aNumber member: anObject

	self maximum: aNumber.
	self members add: anObject! !
